---
hide:
  - navigation
  - toc
---

# OneFlow 全新一代深度学习框架

## OneFlow 是什么
OneFlow 是开源的、采用全新架构设计，世界领先的工业级通用深度学习框架。

## 为什么是OneFlow

* 分布式训练全新体验，多机多卡如单机单卡一样简单

* 完美契合一站式平台(k8s + docker)

* 原生支持超大模型

* 近零运行时开销、线性加速比

* 灵活支持多种深度学习编译器

* 自动混合精度

* 中立开放，合作面广

* 持续完善的算子集、模型库

我们致力于打造一款满足开发者所有美好想象的深度学习框架，期待广大开发者试用、反馈、合作。

## 从哪开始

可以在[快速上手](quick_start/install.md)学习如何安装并快速运行 OneFlow。

在[基础专题](basics_topics/data_input.md)中我们介绍了如何使用 OneFlow 完成机器学习的常见任务，如搭建网络、配置超参、加载数据、分布式训练等。

在[扩展专题](extended_topics/job_function_define_call.md)中我们介绍了具有 OneFlow 自身特点的话题，如 OneFlow 数据集格式、OneFlow 的并行观、开发者如何使用 VS Code 调试 OneFlow 框架等。


最后，期待广大开发者、机器学习爱好者参与 [OneFlow 开源计划](contribute/intro.md)，共创、共享，一起打造迈向完美的深度学习框架。
