As an open source infrastructure framework with prominent competitiveness and solid foundation, OneFlow is still in rapid development and improvement.

OneFlow can't grow without the friends who love open source. Every line of code you contribute, every issue you submit, every bug you report, even every question you ask, is precious to OneFlow.

## Grow up with OneFlow

Contributing code, adding API docstring, fixing bugs and submiting issues, reviewing code ...

OneFlow looks forward to your help in every way.

You can participate in OneFlow's open source project by choosing one or more of the following, depending on your situation.

* Contribute code
* Contribute test cases
* Improve documentation
* Review pull requests from others
* Recommend OneFlow to people who need it
* Participate in OneFlow's group discussion
* …… All the things you can think of to make OneFlow better


## Contribute code

Our main open source code repository are：

* [oneflow](https://github.com/Oneflow-Inc/oneflow): It contains codes of OneFlow framework.

* [OneFlow-Benchmark](https://github.com/Oneflow-Inc/OneFlow-Benchmark): It provides OneFlow deep learning benchmark examples for CV, CTR and NLP, and more models are on the way and will be provided here when ready.

You can also find or create more OneFlow open source projects [here](https://github.com/Oneflow-Inc).

## Contribute test cases

OneFlow has reproduced and tested a lot of popular models, some related scripts and documents are placed in [OneFlow-Benchmark](https://github.com/Oneflow-Inc/OneFlow-Benchmark) repository.

But there are more models that are not covered by OneFlow, we are looking forward to your help to bring them to OneFlow.

We also strongly encourage using OneFlow in your own original research and sharing it in [OneFlow-Benchmark](https://github.com/Oneflow-Inc/OneFlow-Benchmark) repository.

## Improve documentation

The API documents of OneFlow are generated by `sphinx` to extract the annotation and docstring from source code.

The API documents project is placed in the docs folder of the [oneflow](https://github.com/Oneflow-Inc/oneflow) repository, we can generate it by the following commands.

```
cd oneflow/docs && make dev
```

We are looking forward to your help in adding `docstring` and `function annotation` to source code for [OneFlow Python API](https://github.com/Oneflow-Inc/oneflow/tree/develop/oneflow/python).

## Review

We are committed to building OneFlow into a basic software product full of industrial beauty with the mentality of creating artworks. This process is also inseparable with code review from open source community.

We are looking forward to your submission of more issues, pull requests and reviews in each repository. We are also looking forward to your participation.
