---
hide:
  - navigation
  - toc
---

# OneFlow: A Whole New Generation Of Deep Learning Framework

An open source deep learning framework with whole new frame design and the world's leading technology for distributed system.

## Key Features & Capabilities

* Make distributed training with multi-machines and multi-devices so simple as on single device.

* Perfectly support container platforms(k8s & docker)

* Handle large models easily

* Almost zero runtime overhead & linear speedup

* Support multiple deep learning compilers(XLA, TensorRT etc)

* Support automatic mixed precision

* Will support more operators and models sustainsouly etc.

We are trying to build a deep learning framework that will amaze everyone!

Looking forward to your [feedbacks](https://github.com/Oneflow-Inc/oneflow/issues) and welcome to join our [contributor community](contribute/intro.md).

## Get Started

- Follow the [instructions](quick_start/install.md) to install OneFlow.

- Tackle the common tasks of machine learning with OneFlow in [Basic topics](basics_topics/data_input.md). Such as building network, hyper-parameters configuration, loading data, distributed training and so on.

- If you want to know more about the characteristics of OneFlow, such as the format of OneFlow's dataset, the parallelism view of OneFlow or how to debug OneFlow framework with vscode, please refer to [extended topic](extended_topics/job_function_define_call.md).

We highly expect developers and geeks to join our [contributor community](contribute/intro.md). Together we can build a perfect deep learning framework.
